
// doxygen 1.8.13 does not mark class B as abstract


#include <type_traits>


class A
{
public:

    virtual ~A() {}

    virtual void test() = 0;

};


class B : public A
{
public:

    virtual ~B() {}

    // virtual void test() = 0;

};


class C : public B
{
public:

    virtual ~C() {}

    virtual void test() override {}

};


static_assert(std::is_abstract<A>(), "A ought to be abstract.");
static_assert(std::is_abstract<B>(), "B ought to be abstract.");
static_assert(!std::is_abstract<C>(), "C ought not to be abstract.");


// A* p1 = new B;
A* p2 = new C;

